//definicije funkcija i nekih klasa iz Dipl1.cpp

class Point{
public:
	GLfloat x, y, z;

	Point::Point(){}
	Point::Point(GLfloat x1, GLfloat y1, GLfloat z1){
		x = x1; y = y1; z = z1;
	}
	Point::~Point(){}

	GLvoid Point::operator=(Point p){
		this->x = p.x;
		this->y = p.y;
		this->z = p.z;
	}

	double Point::Udaljenost(Point p){
		double xT,yT,zT,x1,y1,z1;
		xT = x - p.x;
		yT = y - p.y;
		zT = z - p.z; 
		x1 = xT*xT; y1 = yT*yT; z1 = zT*zT;
		return sqrt(x1+y1+z1);
	}

	Point Point::operator-(Point p){
		Point rez;
		rez.x = x - p.x;
		rez.y = y - p.y;
		rez.z = z - p.z;
		return rez;
	}

};

class Vector{
public:
	GLfloat x, y, z;
	Vector::Vector(){}
	Vector::Vector(Point p){
		x = p.x; y = p.y; z = p.z;
	}
	Vector::~Vector(){}

	GLfloat Vector::Dot(Vector v){
		return (x*v.x + y*v.y + z*v.z);
	}
	Vector Vector::Cross(Vector v){
		Vector rez;
		rez.x = y*v.z - z*v.y;
		rez.y = -(x*v.z - z*v.x);
		rez.z = x*v.y - y*v.x;
		return rez;
	}

	GLvoid Vector::Normalize(){
		GLfloat n;
		n = sqrt(x*x + y*y + z*z);
		x /= n; y /= n; z /= n;
	}

	GLvoid Vector::operator=(Vector v){
		this->x = v.x;
		this->y = v.y;
		this->z = v.z;
	}

};

struct Triangle{
	GLint vert1, vert2, vert3;
};

GLvoid StartPicking();
GLvoid StopPicking();
GLvoid DrawPickScene();
GLvoid Cleanup();
GLvoid InitScene();
GLvoid CalculateMeshNormals(Point vertexList[], GLint nVert, Triangle triangleList[],
							GLint nTri, Point normalList[], Point vertNormalList[]);
GLint CalculateDenseSurfaceCorrespondences();
GLvoid CyllindricalProjection(Point SourceMesh[], int nS, Point TargetMesh[],
								int nT, Triangle TargetTri[], int nTri, 
								Point TargetNormal[], int barFlag);
GLvoid CalculateCoordSystems(Point SourceMesh[], int nS, Point SourceDefMesh[],
							  Triangle SourceTri[], int nSourceTri, Point SourceNorm[], 
							  Point SourceDefNorm[]);
GLvoid CalculateAdjustedMotionVectors(int nS, int nT, Point src[], Triangle trn[],
									  Point srcDef[]);
GLvoid CalculateTargetMotionVectors(int nT, Triangle sourceTri[], Vector mV[],
									Point target[]);
