// MyPoint.h: interface for the MyPoint class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MYPOINT_H__33E455C2_98C0_11D1_982A_00A0C98A5C22__INCLUDED_)
#define AFX_MYPOINT_H__33E455C2_98C0_11D1_982A_00A0C98A5C22__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <math.h>

template <class TYPE>
class My2CPoint 
{
	public :
		My2CPoint(TYPE xval, TYPE yval) 
			{ x = xval; y =  yval;}
		virtual ~My2CPoint() { }
		My2CPoint() { x=y=0;}
		My2CPoint(My2CPoint *p) 
			{  x = p->x ;  y = p->y; }

		//------------- get xyz coordinate values -----------
		TYPE GetX() { return x;}
		TYPE GetY() { return y;}
		My2CPoint* Get()  {return this;}

		//------------- set xy coordinate values -----------
		void SetX(TYPE xval) { x = xval;}
		void SetY(TYPE yval) { y = yval;}
		void Set(const My2CPoint *p) { x = p -> x; y = p -> y; }
		void Set(TYPE xval, TYPE yval) {x = xval; y = yval;}

		//--------------------------- binary '*' operator overloading -------------------
		My2CPoint<TYPE> operator*(const TYPE val)
		{
			My2CPoint<TYPE> temp;
			temp.x = x * val;
			temp.y = y * val;
			return temp;
		}
		My2CPoint<TYPE> operator*(const My2CPoint<TYPE> pnt)
		{
			My2CPoint<TYPE> temp;
			temp.x  = x * pnt.x;
			temp.y  = y * pnt.y;
			return temp;
		}
		TYPE dot(My2CPoint<TYPE> pnt)
		{
			return ( x*pnt.GetX() + y*pnt.GetY() );	
		}

		//--------------------------- binary '/' operator overloading -------------------
		My2CPoint<TYPE> operator/(const TYPE val)
		{
			My2CPoint<TYPE> temp;
			temp.x = x / val;
			temp.y = y / val;
			return temp;
		}

		//--------------------------- unary operator definition -------------------------
		My2CPoint<TYPE> operator-()
		{
                        My2CPoint<TYPE> temp;
			temp.x = -x;temp.y = -y;
			return temp;
		}
		My2CPoint<TYPE> operator+()
		{
                        My2CPoint<TYPE> temp;
                        temp.x = x;temp.y = y;
                        return temp;
		}
		//--------------------------- binary operator definition -------------------
		My2CPoint<TYPE> operator+(const My2CPoint<TYPE> pnt)
		{
			My2CPoint<TYPE> temp;
			temp.x  = x + pnt.x;
			temp.y  = y + pnt.y;
			return temp;
		}
		My2CPoint<TYPE> operator-(const My2CPoint<TYPE> pnt)
		{
			My2CPoint<TYPE> temp;
			temp.x  = x - pnt.x;
			temp.y  = y - pnt.y;
			return temp;
		}

		My2CPoint<TYPE>& operator=(const My2CPoint<TYPE> &pnt)
		{
			x =  pnt.x; y = pnt.y; 
			return (*this);
		}

		My2CPoint<TYPE>& operator+=(const My2CPoint<TYPE> &pnt)
		{
			*this = *this + pnt;
			return (*this);
		}

		My2CPoint<TYPE>& operator*=(const My2CPoint<TYPE> &pnt)
		{
			*this = *this * pnt;
			return (*this);
		}

		My2CPoint<TYPE>& operator-=(const My2CPoint<TYPE> &pnt)
		{
			*this = *this - pnt;
			return (*this);
		}

		int operator==(My2CPoint<TYPE> pnt)
		{
			if ( (x == pnt.GetX()) && (y == pnt.GetY()) )
				return 1;
			return 0;
		}
		int operator!=(My2CPoint<TYPE> pnt)
		{
			return !operator==( pnt );
		}

		//My2CPoint<TYPE>& minp( const My2CPoint<TYPE> pnt1, const My2CPoint<TYPE> pnt2)
		My2CPoint<TYPE>& minp( My2CPoint<TYPE> pnt1, My2CPoint<TYPE> pnt2)
		{
			*this = pnt1;
			if ( GetX() > pnt2.GetX() )
				SetX( pnt2.GetX() );
			if ( GetY() > pnt2.GetY() )
				SetY( pnt2.GetY() );
			return *this;
		}

		My2CPoint<TYPE>& maxp( My2CPoint<TYPE> pnt1, My2CPoint<TYPE> pnt2)
		{
			*this = pnt1;
			if ( GetX() < pnt2.GetX() )
				SetX( pnt2.GetX() );
			if ( GetY() < pnt2.GetY() )
				SetY( pnt2.GetY() );
			return *this;
		}

		TYPE length()
		{
			return ( (TYPE) sqrt( x*x + y*y ) );
		}

		My2CPoint<TYPE>& normalize()
		{
			TYPE temp = (TYPE) length();
			x /= temp;
			y /= temp;
			return *this;	
		}
		

		TYPE distance( My2CPoint<TYPE> pnt )
		{
			return (TYPE) sqrt( (x - pnt.GetX())*(x - pnt.GetX())+
				     (y - pnt.GetY())*(y - pnt.GetY()));
		}

	private :
		TYPE	x,y;	

};

template <class TYPE>
class My3CPoint 
{
	public :

		My3CPoint(TYPE xval, TYPE yval, TYPE zval) 
			{ x = xval; y =  yval;z = zval;}

		virtual ~My3CPoint() {}

		My3CPoint() { x = y = z = 0; }

		My3CPoint(My3CPoint *p) { x = p -> x ; y = p -> y ; z = p -> z; }


		//------------- get xyz coordinate values -----------

		TYPE GetX() { return x; }
		TYPE GetY() { return y; }
		TYPE GetZ() { return z; }
		My3CPoint* Get() { return this; }


		//------------- set xyz coordinate values -----------

		void SetX(TYPE xval) { x = xval; }
		void SetY(TYPE yval) { y = yval; }
		void SetZ(TYPE zval) { z = zval; }
		void Set(TYPE xval, TYPE yval, TYPE zval) { x = xval; y = yval; z = zval; }


		//--------------------------- binary '*' operator overloading -------------------

		My3CPoint<TYPE> operator*( const TYPE val )
		{
			My3CPoint<TYPE> temp;
			temp.x = x * val;
			temp.y = y * val;
			temp.z = z * val;
			return temp;
		}

		My3CPoint<TYPE> operator*( const My3CPoint<TYPE> pnt )
		{
			My3CPoint<TYPE> temp;
			temp.x  = x * pnt.x;
			temp.y  = y * pnt.y;
			temp.z  = z * pnt.z;
			return temp;
		}


	 	//--------------------------- binary '/' operator overloading -------------------

		My3CPoint<TYPE> operator/(const TYPE val)
		{
			My3CPoint<TYPE> temp;
			temp.x = x / val;
			temp.y = y / val;
			temp.z = z / val;
			return temp;
		}


		//--------------------------- unary operator definition -------------------------

		My3CPoint<TYPE> operator-()
		{
                        My3CPoint<TYPE> temp;
			temp.x = -x;temp.y = -y;temp.z = -z;
			return temp;
		}

		My3CPoint<TYPE> operator+()
		{
                        My3CPoint<TYPE> temp;
                        temp.x = x;temp.y = y;temp.z = z;
                        return temp;
		}

		TYPE dot(My3CPoint<TYPE> pnt)
		{
			return ( x*pnt.GetX() + y*pnt.GetY() + z*pnt.GetZ() );	
		}


		//--------------------------- binary operator definition -------------------

		My3CPoint<TYPE> operator+(const My3CPoint<TYPE> pnt)
		{
			My3CPoint<TYPE> temp;
			temp.x  = x + pnt.x;
			temp.y  = y + pnt.y;
			temp.z  = z + pnt.z;
			return temp;
		}

		My3CPoint<TYPE> operator-(const My3CPoint<TYPE> pnt)
		{
			My3CPoint<TYPE> temp;
			temp.x  = x - pnt.x;
			temp.y  = y - pnt.y;
			temp.z  = z - pnt.z;
			return temp;
		}

		My3CPoint<TYPE>& operator=(const My3CPoint<TYPE> &pnt)
		{
			x =  pnt.x; y = pnt.y; z = pnt.z;
			return (*this);
		}

		My3CPoint<TYPE>& operator+=(const My3CPoint<TYPE> &pnt)
		{
			*this = *this + pnt;
			return (*this);
		}

		My3CPoint<TYPE>& operator*=(const My3CPoint<TYPE> &pnt)
		{
			*this = *this * pnt;
			return (*this);
		}

		My3CPoint<TYPE>& operator-=(const My3CPoint<TYPE> &pnt)
		{
			*this = *this - pnt;
			return (*this);
		}

		int operator==(My3CPoint<TYPE> pnt)
		{
			if ( (x == pnt.GetX()) && (y == pnt.GetY()) && (z == pnt.GetZ()))
				return 1;
			return 0;
		}

		int operator!=(My3CPoint<TYPE> pnt)
		{
			return !operator==( pnt );
		}

		My3CPoint<TYPE>& minp( My3CPoint<TYPE> pnt1, My3CPoint<TYPE> pnt2)
		{
			*this = pnt1;
			if ( GetX() > pnt2.GetX() )
				SetX( pnt2.GetX() );
			if ( GetY() > pnt2.GetY() )
				SetY( pnt2.GetY() );
			if ( GetZ() > pnt2.GetZ() )
				SetZ( pnt2.GetZ() );
			return *this;
		}

		My3CPoint<TYPE>& maxp( My3CPoint<TYPE> pnt1, My3CPoint<TYPE> pnt2)
		{
			*this = pnt1;
			if ( GetX() < pnt2.GetX() )
				SetX( pnt2.GetX() );
			if ( GetY() < pnt2.GetY() )
				SetY( pnt2.GetY() );
			if ( GetZ() < pnt2.GetZ() )
				SetZ( pnt2.GetZ() );
			return *this;
		}
		TYPE length()
		{
			return ( (TYPE) sqrt( x*x + y*y + z*z ) );
		}

		My3CPoint<TYPE>& normalize()
		{
			float temp = length();
			if ( temp )
			{
				x /= temp;
				y /= temp;
				z /= temp;
			}
			return *this;	
		}

		My3CPoint<TYPE> getNormal(My3CPoint<TYPE> *p1, My3CPoint<TYPE> *p2, My3CPoint<TYPE> *p3)
		{
		 // Form two vectors from the points
			Point3f a,b;
			a.SetX(p2->GetX() - p1->GetX());
			a.SetY(p2->GetY() - p1->GetY());
			a.SetZ(p2->GetZ() - p1->GetZ());

			b.SetX(p3->GetX() - p1->GetX());
			b.SetY(p3->GetY() - p1->GetY());
			b.SetZ(p3->GetZ() - p1->GetZ());

		 // Calculate the cross product of the two vectors
			SetX(a.GetY()*b.GetZ() - a.GetZ()*b.GetY());
			SetY(a.GetZ()*b.GetX() - a.GetX()*b.GetZ());
			SetZ(a.GetX()*b.GetY() - a.GetY()*b.GetX());

		 // normalize the vector
			normalize();

			return *this;
		}

		TYPE distance( My3CPoint<TYPE> pnt )
		{
			return (TYPE) sqrt( (x - pnt.GetX())*(x - pnt.GetX())+
				     (y - pnt.GetY())*(y - pnt.GetY())+
				     (z - pnt.GetZ())*(z - pnt.GetZ()));
		}

	private :
			
		TYPE  x, y, z;
};

typedef My3CPoint<double> Point3d;
typedef My3CPoint<float> Point3f;
typedef My3CPoint<int> Point3i;

typedef My2CPoint<double> Point2d;
typedef My2CPoint<float> Point2f;
typedef My2CPoint<int> Point2i;

#endif // !defined(AFX_MYPOINT_H__33E455C2_98C0_11D1_982A_00A0C98A5C22__INCLUDED_)
